--[[ My ]]
TargetPriority = {}


--[[ Public ]]
function TargetPriority.GetPriority( Priority )
	Trace("TargetPriority","Start")
	
	local PriorityList = List.New()
	local ActorData	= {}
	local PrimTgt		= 0
	local IFF			= 0
	
	for i=1, string.len(Priority) do
		IFF=string.sub(Priority, i, i)
		Trace("Priority  " .. i .. " : " .. IFF, "Start")
		
		if IFF==IFF_ENEMY then
			PrimTgt = TargetPriority.GetPrimaryTarget(ACT_ENEMY)
			List.SetRight(PriorityList, IFF, PrimTgt)
			
		elseif IFF==IFF_OWNER then
			List.SetRight(PriorityList, IFF, My.Owner.ID)		
			
		elseif IFF==IFF_FRIEND then
			PrimTgt = TargetPriority.GetPrimaryTarget(ACT_FRIEND)
			List.SetRight(PriorityList, IFF, PrimTgt.ID)
			
		elseif IFF==IFF_ME then
			List.SetRight(PriorityList, IFF, My.ID)
			
		end
		
		Trace("Priority  " .. i .. " : " .. IFF, "End")
		ActorData = nil
	end
	
	Trace("TargetPriority","End")
	return PriorityList
end

--[[ Public ]]
function TargetPriority.GetPrimaryTarget(ActorType)	
	local PrimaryTarget = { ID=0, Priority=0 }
	local ActorIDList = Finding.GetActorIDList(ActorType)
	local ActorData

	for Index, ActorID in pairs(ActorIDList) do
		if List.IsItem(Index) then
			if ActorType==ACT_ENEMY then
				ActorData = Finding.GetActorData(ActorID)
				ActorData.Priority, ActorData.SkillAttackPriority = Evaluation.EnemyEvaluation(My, ActorData)
				Finding.SetActorData(ActorData)
				
			elseif ActorType==ACT_FRIEND then
				ActorData = Finding.GetActorData(ActorID)
				ActorData.Priority = Evaluation.FriendEvaluation(ActorData)
				Finding.SetActorData(ActorData)
				
			end
			
			if PrimaryTarget.Priority < ActorData.Priority then
				PrimaryTarget.Priority	= ActorData.Priority
				PrimaryTarget.ID		= ActorData.ID
			end
			Trace("", "", TRACE_PARAM )
		end
	end
	
	return PrimaryTarget
end
