--[[ Finding ]]
--[[ List ]]
--[[ Actor ]]
ifAttack = {}
local AttackAction = {}


---------------------


--[[ Public ]]
function ifAttack.InFight(TargetID)
	AttackAction.InFight(TargetID)	
end

--[[ Public ]]
function ifAttack.Skill(Skill, Level, TargetID)
	AttackAction.Skill(Skill, Level,TargetID)
end

--[[ Public ]]
function ifAttack.Rampage(TargetID)
	AttackAction.Rampage(TargetID)
end


-------------------


--[[ Private ]]
function AttackAction.InFight(TargetID)
	if not My.IsDelay() then
		Attack(My.ID, TargetID)
		My.SetDelay( DELAY_ATTACK )
	end
end

--[[ Private ]]
function AttackAction.Skill(Skill, Level, TargetID)
	if not My.IsDelay() then
		if not AttackAction.IsSkillActivate(Skill) then
			local SkillData = SkillDataAccesser.GetSkillData(Skill)
			
			if SkillData.SP < My.GetSP() then
				if IsNil(TargetID) then TargetID=My.ID end
				
				if IsNil(Level)		then Level=1 end
				if IsNil(TargetID)	then TargetID = My.ID end
				
				SkillObject(My.ID, Level, Skill, TargetID)
				List.SetLeft(My.UsingSkill, Skill, SkillData.ActivateTime)
				My.SetDelay(SkillData.Delay)
			end
		end
	end
end

--[[ Private ]]
function AttackAction.SkillGround(Skill, Level, TgtX, TgtY)
	SkillGround(My.ID, Level, Skill, TgtX, TgtY)
end

--[[ Private ]]
function AttackAction.Rampage(TargetID)
	AttackAction.InFight(TargetID)
end

--[[ Private ]]
function AttackAction.IsSkillActivate( Skill )
	local SkillData = List.Get(My.UsingSkill, Skill)
	
	if IsNil(SkillData) then
		return false
	else
		return true
	end
end

--[[ Private ]]
function AttackAction.IsEnchantSkill( Skill )
	-- [t
	if 8001<=Skill and Skill<=8004 then
		if Skill==SKILL_TOUCH_OF_HEAL or Skill==SKILL_EMERGENCY_AVOID or Skill==	SKILL_BRAIN_SURGERY or Skill==	SKILL_MENTAL_CHANGE then
			return true
		end
		
	-- A~Xg
	elseif 8005<=Skill and Skill<=8008 then
		if Skill==SKILL_DEFENCE or Skill==SKILL_ADAMANTIUM_SKIN then
			return true
		end
		
	-- tB[
	elseif 8009<=Skill and Skill<=8012 then
		if Skill==SKILL_FLEET_MOVE or Skill==SKILL_OVERED_SPEED then
			return true
		end
		
	-- oj~g
	elseif 8013<=Skill and Skill<=8016 then
		if Skill==SKILL_CHANGE_INSTRUCTION then
			return true
		end
		
	end
	
	return false
end
